// ==UserScript==
// @name        MH - Mr X - mithril
// @namespace   MH
// @description Affichage des unités de mithril (UM) des trésors et minerais, version 1.3 du 16-04-2022 par Vapulabehemot (82169)
// @include		*/MH_Play/Play_equipement*
// @include		*/MH_Taniere/TanierePJ_o_Stock*
// @include		*/MH_Comptoirs/Comptoir_o_Stock*
// @include		*/MH_Play/Play_e_follo*
// @include		*/MH_Follower/FO_Equipement*
// @include		*/View/TresorHistory*
// @icon        https://mz.mh.raistlin.fr/mz/img/mz_logo_small.png
// @version     1.3
// @grant       none
// ==/UserScript==

// Script d'affichage des unités de mithril (UM) des trésors et minerais

// TODO
// Gestion du taillé
// Gestion non identifié en tanière et GT et gowap

/* Reprise des fonctions de MZ, ajout Vapulabehemot */
function isPage(url) {
	return window.self.location.toString().indexOf(url) !== -1;
}
function trim(str) {
	return str.replace(/(^\s*)|(\s*$)/g,'');
}
function appendText(paren,text,bold) {
	if(bold) {
		var b = document.createElement('b');
		b.appendChild(document.createTextNode(text));
		paren.appendChild(b);
	}
	else {
		paren.appendChild(document.createTextNode(text));
	}
}


var intervalId = null; // ajout Vapulabehemot

// Renvoie le nombre d'UM d'un minerai (texte)
function getMineraiUm(texte) {

//	if (mineraiParts = texte.match(/Taille:\s*(\d+)\s*unités?\s*\|\s*Qualité:\s*([^\s]*)/)) {	
	if (mineraiParts = texte.match(/Taille:\s*(\d+)\s*unités?\s*\|\s*Carats?\s*:\s*\d+\s*\|\s*Qualité:\s*([^\s]*)/)) {	// modif Vapulabehemlot 16-04-2022
			// Est un minerai
		var mineraiTaille = mineraiParts[1];
		var mineraiQualite = mineraiParts[2];
		var mineraiUM = mineraiTaille * getMineraiUmRatio(mineraiQualite);
		//mineraiUM = Math.round(mineraiUM); // Arrondi au plus proche
		mineraiUM = Math.floor(mineraiUM); // Arrondi à l'inférieur //modif Vapulabehemot
		return mineraiUM;		
	}
	
	return false;
}

// Renvoie le nombre d'UM d'un minerai (2 paramètres)
function getMineraiUm2(taille, qualite) {
	var matches, intTaille = 0;
	if (matches = taille.match(/^(\d+) unité/)) {
		intTaille = matches[1];
	}
	var mineraiUM = intTaille * getMineraiUmRatio(qualite); 
	//mineraiUM = Math.round(mineraiUM); // Arrondi au plus proche
	mineraiUM = Math.floor(mineraiUM); // Arrondi à l'inférieur //modif Vapulabehemot
	return mineraiUM;
}

// Renvoie le ratio UM/taille d'une qualité de minerai
function getMineraiUmRatio(qualite) {
	if (qualite == "Médiocre") return 0.2;
	else if (qualite == "Moyenne") return 0.4;
	else if (qualite == "Normale") return 0.6;
	else if (qualite == "Bonne") return 0.8;
	else if (qualite == "Exceptionnelle") return 1;
	else return 0;
}

// Renvoie le nombre d'UM d'un équipement
function getTresorUm(tresor) {
	var mapping = {
		"Armure d'anneaux" : 64,
		"Armure de Plates" : 80,
		"Bouclier à Pointes" : 28,
		"Boulet et chaîne" : 12,
		"Casque à cornes" : 8,
		"Casque à Pointes" : 10,
		"Casque en métal" : 8,
		"Chaîne Cloutée" : 28,
		"Collier à Pointes" : 2,
		"Cotte de Mailles" : 56,
		"Crochet" : 10,
		"Cuirasse d'écailles" : 48,
		"Dague" : 4,
		"Epée Courte" : 8,
		"Epée Longue" : 16,
		"Espadon" : 32,
		"Gantelet" : 6,
		"Gorgeron en métal" : 4,
		"Gros'Porte" : 40,
		"Hache de Bataille" : 24,
		"Hallebarde" : 48,
		"Haubert d'écailles" : 64,
		"Haubert de mailles" : 72,
		"Heaume" : 16,
		"Jambières en maille" : 16,
		"Jambières en métal" : 20,
		"Machette" : 16,
		"Masse d'Arme" : 12,
		"Pagne de Mailles" : 6,
		"Rondache en métal" : 24,
		"Targe" : 4
	};
	for (var oneTresor in mapping) {
		if (oneTresor.toLowerCase() === tresor.substr(0, oneTresor.length).toLowerCase()) {
			return mapping[oneTresor];
		}
	}
	return 0;
}

// Renvoie le nombre d'UM d'un équipement en Mithril en fonction de son poids, ajout par Vapulabehemot
function getTresorUm2(poids) {
	var matches, floatPoids = 0;
	if (matches = poids.match(/\((.+) minutes?\)/)) {
		floatPoids = parseFloat(matches[1]);
	}
	var mineraiUM = floatPoids * 1.6; 
	mineraiUM = Math.round(mineraiUM); // Arrondi au plus proche
	return mineraiUM;
}

// Gère le minerai de la page Petits équipements
function treateMineraiEquip() {
	
	intervalId = attenteModal(intervalId); // ajout Vapulabehemot

	//var nodes = document.evaluate("//img[@alt = 'Minerai - Spécial']/../a/text()",
	var nodes = document.evaluate("//a[starts-with(.,'Mithril')]", //modif Vapulabehemot
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

	if (nodes.snapshotLength == 0)
		return false;

	var total = 0;
	for (var i = 0; i < nodes.snapshotLength; i++) {
		//var node = nodes.snapshotItem(i);
		var node = nodes.snapshotItem(i).parentNode.parentNode.childNodes[9]; //modif Vapulabehemot

		//var texte = trim(node.nodeValue.replace(/\240/g, " "));
		var texte = trim(node.innerHTML.replace(/\240/g, " ")); //modif Vapulabehemot
		
		var um = getMineraiUm(texte);

		if (um !== false) {
			total += um;
			//node.parentNode.parentNode.innerHTML += "[" + um + "&nbsp;UM]";
			node.previousSibling.previousSibling.innerHTML += " [" + um + "&nbsp;UM]"; //modif Vapulabehemot
		}
 
	}
	// Total
	//var nodes = document.evaluate("//p[.='Minerais']",
	var nodes = document.evaluate("//b[.='Minerai']", //modif Vapulabehemot	
		document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var node = nodes.snapshotItem(0);
	totalNode = document.createElement('span');
	totalNode.setAttribute('style', 'font-size: 12px;');
	appendText(totalNode, " - Total : " + total + " UM");
	node.appendChild(totalNode);
	
	return total;
}


// Gère le minerai sur les Gowaps // ajout Vapulabehemot
function treateMineraiGowap() {

	intervalId = attenteModal(intervalId);

	var nodes = document.evaluate("//a[starts-with(.,'Mithril')]",
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

	if (nodes.snapshotLength == 0)
		return false;

	var total = 0;
	for (var i = 0; i < nodes.snapshotLength; i++) {
		var node = nodes.snapshotItem(i).parentNode.parentNode.childNodes[7];

		var texte = trim(node.innerHTML.replace(/\240/g, " "));
		
		var um = getMineraiUm(texte);

		if (um !== false) {
			total += um;
			//node.previousSibling.previousSibling.innerHTML += "[" + um + "&nbsp;UM]";
			node.previousSibling.previousSibling.innerHTML += " [" + um + "&nbsp;UM]"; //modif Vapulabehemot
		}
 
	}
	// Total
	var nodes = document.evaluate("//div[starts-with(.,'Equipement')]", // total pour la page d'Equipement d'un Gowap
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (nodes.snapshotLength == 0) {
		nodes = document.evaluate("//h2[.='MES SUIVANTS']", // total pour la page avec tous les Gowaps
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	}
	var node = nodes.snapshotItem(0);
	totalNode = document.createElement('span');
	totalNode.setAttribute('style', 'font-size: 12px;');
	appendText(totalNode, " - Total Minerais : " + total + " UM");
	node.appendChild(totalNode);
	
	return total;
}

// Gère le minerai en tanière / GT
function treateMineraiTaniere() {

	intervalId = attenteModal(intervalId); // ajout Vapulabehemot

	var nodes = document.evaluate("//a[starts-with(.,'Mithril')]",
		document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (nodes.snapshotLength == 0)
		return false;

	var total = 0;
	for (var i = 0; i < nodes.snapshotLength; i++) {
		var node = nodes.snapshotItem(i);
		if (node.href.indexOf('ai_IDTresor') != - 1){ 
			try {
				var node2 = node.parentNode.parentNode.childNodes[7];
				var texte = node2.innerHTML;
				var um = getMineraiUm(texte);
				if (um !== false) {
					total += um;
					//node.parentNode.innerHTML += "[" + um + "&nbsp;UM]";
					node.parentNode.innerHTML += " [" + um + "&nbsp;UM]";  //modif Vapulabehemot
				}
			} catch (e) {}
		}
	}
	
	// Total : zone "Minerai"
	//var nodes = document.evaluate("//td[@class='mh_titre3' and contains(., 'Minerai')]/b", 
	var nodes = document.evaluate("//tr[@class='mh_tdtitre' and contains(., 'Minerai')]/th", //modif Vapulabehemot
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null); 
	if (nodes.snapshotLength == 0) return false; //ajout Vapulabehemot
	var node = nodes.snapshotItem(0);
	// Conflit avec Mountyzilla qui ajoute un form dans le titre "Minerai"
	// Donc on efface d'abord le titre "Minerai" puis on le rajoute
	node.firstChild.nodeValue = "";
	node.innerHTML = 'Minerai<span style="font-size:12px;"> - Total : '
		+ total + ' UM</span>' + node.innerHTML;

	// Total : tout en haut
	//var nodes = document.evaluate("//div[@class='titre3']",
	// var nodes = document.evaluate("//div/h3", // modif Vapulabehemot
			// document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	// var node = nodes.snapshotItem(0);
	var node = document.getElementById('titre2');// modif Vapulabehemot
	//node.innerHTML += '<span style="font-size:12px;"> - Total : '
	node.innerHTML += '<span style="font-size:12px;"> - Total Minerais : ' // modif Vapulabehemot
		+ total + ' UM</span>';
	
	return total;
}

// Gère le minerai dans la page d'historique d'un trésor 
// function treateMineraiHisto() {

	// // Lecture des infos
	// var infos = {};
	// //var rows = document.evaluate("/html/body/table[2]//table//tr",
	// var rows = document.evaluate("//div[@class='modal']/table[2]//table//tr", // modif Vapulabehemot
			// document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

	// for (var i = 0; i < rows.snapshotLength; i++) {
		// var node = rows.snapshotItem(i);
		// if (node.innerHTML.indexOf(' :') != -1) { // ajout Vapulabehemot
			// var key = node.firstChild.firstChild.innerHTML;
			// key = key.replace(/ :/, '');
			// var val = node.childNodes[1].innerHTML;
			// infos[key] = val;
		// }
	// }

	// // Est du mithril ?
	// if (infos.Matériau === 'Mithril') {
		// if (infos.Type === 'Minerai') {
			// var um = getMineraiUm2(infos.Taille, infos.Qualité);
		// }
		// else { // ajout Vapulabehemot
			// var um = getTresorUm2(infos.Poids);
		// }
		// writeHistoUm(um);
	// }

	// return um;
// }

// Gère les équipements de la page d'équipement ou tanière/GT
function treateTresorEquipTaniere(showTotal) {

	intervalId = attenteModal(intervalId); // ajout Vapulabehemot

	var nodes = document.evaluate("//a[contains(.,' Mithril')]",
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (nodes.snapshotLength == 0)
		return false;

	var total = 0;
	var plusIndetermine = '';
	for (var i = 0; i < nodes.snapshotLength; i++) {
		var node = nodes.snapshotItem(i);
		//var texte = trim(node.innerHTML.replace(/\240/g, " "));
    var texte = trim(node.innerText.replace(/\240/g, ' ').replace(/\[\d*\]/, '')); // modif Vapulabehemot
		var um = getTresorUm(texte);
		if (um > 0) {
			total += um;
			//node.parentNode.innerHTML += "[" + um + "UM]";
      node.parentNode.innerHTML += " [" + um + "UM]"; // modif Vapulabehemot
		}
		else {
			plusIndetermine = '+';
			node.parentNode.innerHTML += " [?&nbsp;UM]";
		}
	}
	
	if (showTotal) {
		
		// Total : zone du type
		//var nodes = document.evaluate("//td[@class='mh_titre3']/b",
				//document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		//var node = nodes.snapshotItem(0);
		//node.innerHTML += '<span style="font-size:12px;"> - Total : '
			//+ total + ' UM</span>';
		
		// Total : tout en haut
		//var nodes = document.evaluate("//div[@class='titre3']",
		//var nodes = document.evaluate("//div/h3", // modif Vapulabehemot
				//document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		//var node = nodes.snapshotItem(0);
		var node = document.getElementById('titre2');// modif Vapulabehemot
		//node.innerHTML += '<span style="font-size:12px;"> - Total : '
		node.innerHTML += '<span style="font-size:12px;"> - Total' + (document.evaluate("//tr[@class='mh_tdtitre' and contains(., 'Minerai')]/th", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null).snapshotItem(0) == null ? '' : ' Autres') + ' : ' // modif Vapulabehemot
			+ total + plusIndetermine + ' UM</span>';		
	}

	return total;
}

// Permet de traiter la popin d'historique des Trésors lorsqu'elle apparaît, par Vapulabehemot
function attenteModal(intervalId){
	if (intervalId == null) {
		intervalId = window.setInterval(function(){
			if (document.evaluate("//div[@class = 'modal']", document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue
				&& !document.getElementById('ScriptMithril')) {
				treateHisto();
			}
		}, 100);
	}
	return intervalId;
}

// Gère les équipements des Gowaps // ajout Vapulabehemot
function treateTresorGowap() {

	intervalId = attenteModal(intervalId);

	var nodes = document.evaluate("//a[contains(.,' Mithril')]",
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			
	if (nodes.snapshotLength == 0)
		return false;

	var total = 0;
	var plusIndetermine = '';
	for (var i = 0; i < nodes.snapshotLength; i++) {
		var node = nodes.snapshotItem(i);
		var texte = trim(node.innerHTML.replace(/\240/g, " "));
		var um = getTresorUm(texte);
		if (um > 0) {
			total += um;
			node.parentNode.innerHTML += " [" + um + "&nbsp;UM]";
		}
		else {
			plusIndetermine = '+';
			node.parentNode.innerHTML += " [?&nbsp;UM]";
		}
	}
		
	// Total
	var nodes = document.evaluate("//div[starts-with(.,'Equipement')]", // total pour la page d'Equipement d'un Gowap
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (nodes.snapshotLength == 0) {
		nodes = document.evaluate("//h2[starts-with(.,'MES SUIVANTS')]", // total pour la page avec tous les Gowaps
			document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	}
	var node = nodes.snapshotItem(0);
	totalNode = document.createElement('span');
	totalNode.setAttribute('style', 'font-size: 12px;');
	appendText(totalNode, ' - Total' + (document.evaluate("//b[contains(., 'Minerai')]", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null).snapshotItem(0) == null ? '' : ' Autres') + ' : ' + total + plusIndetermine + ' UM');
	node.appendChild(totalNode);
	
	return total;

}

// Gère les équipements dans la page d'historique d'un trésor
// function treateTresorHisto() {
	// var nodes = document.evaluate("//div[@class='titre2' and contains(.,' Mithril')]",
			// document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	// if (nodes.snapshotLength == 0)
		// return false;
		
	// var node = nodes.snapshotItem(0);
	// var texte = trim(node.innerHTML.replace(/\240/g, " ")).replace(/^[0-9\.\s]*/, '');
	// var um = getTresorUm(texte);
	// if (um > 0) {
		// writeHistoUm(um);
	// }

	// return um;
// }

// Affiche le nombre d'um sur une page d'historique
// function writeHistoUm(um) {
	
	// // Ajout au titre
		// var titleNode = document.evaluate("//div[@class='titre2']",
				// document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null)
				// .snapshotItem(0);
		// titleNode.innerHTML += '[' + um + '&nbsp;UM]';

// //	var tableNode = document.evaluate("/html/body/table[2]//table",
	// var tableNode = document.evaluate("//div[@class='modal']/table[2]//table//tbody", // modif Vapulabehemot
				// document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

				// tableNode = tableNode.snapshotItem(0);
	// tableNode.innerHTML += '<tr><td><b>Mithril récupérable :</b></td><td>' + um + '&nbsp;UM</td></tr>';
	
// }


// Gère le minerai et les pièces d'équipement dans la popin/popup d'historique d'un trésor // ajout Vapulabehemot 
function treateHisto() {
	// indication que le traitement a déjà été effectué
	var p = document.createElement('p');
	p.id = 'ScriptMithril';
  var target = document.evaluate("//div[@class = 'modal']", document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
  if (target.singleNodeValue) {
    // uniquement pour la popin
    target.singleNodeValue.appendChild(p);
  }
   
  // Tableaux "Informations" et "Actuellement Porté"
  var tableauNodes = document.evaluate("//div[@class='modal']//table[@class='descr']//tbody", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);  
  if (tableauNodes.snapshotLength === 0){
    // uniquement pour la popup
    tableauNodes = document.evaluate("//table[@class='mh_tdborder']//table[@class='descr']//tbody", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null)
  }
 
	// Lecture des infos
	for (var i = 0; i < tableauNodes.snapshotLength; i++) {
		var um = getUmFromTableauNodes(tableauNodes.snapshotItem(i));

    // Si c'est du Mithril
		if (um) {
			// ajout des UM aux infos
			tableauNodes.snapshotItem(i).innerHTML += '<tr><th>Mithril&nbsp;récupérable&nbsp;:</th><td>' + um + '&nbsp;UM</td></tr>';
			
			// ajout des UM au titre du tableau "Informations" ou "Actuellement Porté"
			tableauNodes.snapshotItem(i).getElementsByTagName('tr')[0].firstChild.innerHTML += ' [' + um + '&nbsp;UM]';

			// ajout des UM au titre de la popin/popup (qui correspond à l'objet du tableau "Informations")
			if (i == 0) {
				var titleNode = document.evaluate("//td[@class='titre2']", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null).snapshotItem(0);
				titleNode.innerHTML += '[' + um + '&nbsp;UM]';
			}
			
		}
		
	}

}

// Gère les infobulles des pièces d'équipement dans la page d'équipemment // ajout Vapulabehemot 
function treateInfobulles() {
  // Infobulles
  var tableauNodes = document.evaluate("//span[@class='spanpopup']//table[@class='descr']//tbody", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);  

	// Lecture des infos
	for (var i = 0; i < tableauNodes.snapshotLength; i++) {
		var um = getUmFromTableauNodes(tableauNodes.snapshotItem(i));

    // Si c'est du Mithril
		if (um) {
			// ajout des UM aux infos
			tableauNodes.snapshotItem(i).innerHTML += '<tr><th>Mithril&nbsp;récupérable&nbsp;:</th><td>' + um + '&nbsp;UM</td></tr>';
			
			// ajout des UM au titre de l'infobulle
			tableauNodes.snapshotItem(i).getElementsByTagName('tr')[0].firstChild.innerHTML += ' [' + um + '&nbsp;UM]';
		}
		
	}

}

// Détermine le nombre d'um à partir d'un tableau d'informations // ajout Vapulabehemot 
function getUmFromTableauNodes(snapshotItem) {
  var infos = {};
  var um;  
	var rows = snapshotItem.getElementsByTagName('tr');
	for (var j = 0; j < rows.length; j++) {
		var node = rows[j];
    if (node.innerHTML.indexOf('#') == -1 && node.innerHTML.indexOf(' :') != -1) {
      var key = node.firstChild.innerHTML;
			key = key.replace(/ :/, '');
			var val = node.childNodes[1].innerHTML;
      infos[key] = val;
		}
  }

    // Si c'est du Mithril
		if (infos.Matériau === 'Mithril') {
      
      // ajustements éventuels
      if (infos.Type === 'Talisman') {
        infos.Poids = infos.Poids.replace('(3 ', '(2.5 ');
      }
      else if (infos.Type === 'Bouclier') {
        infos.Poids = infos.Poids.replace('(3 ', '(2.5 ').replace('(18 ', '(17.5 ');
      }
      else if (infos.Type === 'Bottes') {
        infos.Poids = infos.Poids.replace('(13 ', '(12.5 ');
      }
      else if (infos.Type === 'Arme (1 main)') {
        infos.Poids = infos.Poids.replace('(3 ', '(2.5 ').replace('(8 ', '(7.5 ');
      }
      else if (infos.Type === 'Arme (2 mains)') {
        infos.Poids = infos.Poids.replace('(18 ', '(17.5 ');
      }
      
      // détermination du nombre d'um
			if (infos.Type === 'Minerai') {
				um = getMineraiUm2(infos.Taille, infos.Qualité);
			}
			else {
				um = getTresorUm2(infos.Poids);
			}
    }

    return um;
}


// GO
if (isPage("MH_Play/Play_equipement.php")) {
	treateTresorEquipTaniere(false);
  treateInfobulles(); // ajout Vapulabehemot
	treateMineraiEquip();
} else if (isPage("MH_Taniere/TanierePJ_o_Stock.php") || isPage("MH_Comptoirs/Comptoir_o_Stock.php")) {
	treateMineraiTaniere();
	treateTresorEquipTaniere(true);
} else if (isPage("MH_Play/Play_e_follo.php") || isPage("MH_Follower/FO_Equipement.php")) { // ajout Vapulabehemot
	treateMineraiGowap(); // ajout Vapulabehemot
	treateTresorGowap(); // ajout Vapulabehemot
} else if (isPage("View/TresorHistory.php")) {
	//treateTresorHisto();
	//treateMineraiHisto();
	treateHisto(); // ajout Vapulabehemot
}
